

#ifndef SBK_PYSIDE_GUI_PYTHON_H
#define SBK_PYSIDE_GUI_PYTHON_H

#include <sbkpython.h>
#include <conversions.h>
#include <sbkenum.h>
#include <basewrapper.h>
#include <bindingmanager.h>
#include <memory>

// Module Includes
#include <pyside2_qtcore_python.h>
#include <pyside2_qtgui_python.h>
#include <pyside2_qtwidgets_python.h>
#include <pyside2_qtopengl_python.h>

// Binded library includes
#include <guiwrapper.h>
#include <pysidegui.h>
// Conversion Includes - Primitive Types
#include <typeresolver.h>
#include <qabstractitemmodel.h>
#include <QString>
#include <signalmanager.h>
#include <QStringList>

// Conversion Includes - Container Types
#include <QMultiMap>
#include <QQueue>
#include <QMap>
#include <QLinkedList>
#include <QStack>
#include <QList>
#include <pysideconversions.h>
#include <QPair>
#include <QSet>
#include <QVector>

// Type indices
#define SBK_GUIWRAPPER_IDX                                           0
#define SBK_PYSIDEGUI_IDX                                            1
#define SBK_pyside_gui_IDX_COUNT                                     2

// This variable stores all Python types exported by this module.
extern PyTypeObject** Sbkpyside_guiTypes;

// This variable stores all type converters exported by this module.
extern SbkConverter** Sbkpyside_guiTypeConverters;

// Converter indices
#define SBK_PYSIDE_GUI_QLIST_QMAINWINDOWPTR_IDX                      0 // QList<QMainWindow * >
#define SBK_PYSIDE_GUI_QLIST_INT_IDX                                 1 // QList<int >
#define SBK_PYSIDE_GUI_QLIST_QVARIANT_IDX                            2 // QList<QVariant >
#define SBK_PYSIDE_GUI_QLIST_QSTRING_IDX                             3 // QList<QString >
#define SBK_PYSIDE_GUI_QMAP_QSTRING_QVARIANT_IDX                     4 // QMap<QString, QVariant >
#define SBK_pyside_gui_CONVERTERS_IDX_COUNT                          5

// Macros for type check

namespace Shiboken
{

// PyType functions, to get the PyObjectType for a type T
template<> inline PyTypeObject* SbkType< ::GUIWrapper >() { return reinterpret_cast<PyTypeObject*>(Sbkpyside_guiTypes[SBK_GUIWRAPPER_IDX]); }
template<> inline PyTypeObject* SbkType< ::PySideGUI >() { return reinterpret_cast<PyTypeObject*>(Sbkpyside_guiTypes[SBK_PYSIDEGUI_IDX]); }

} // namespace Shiboken

#endif // SBK_PYSIDE_GUI_PYTHON_H

