

#ifndef SBK_PYSIDE_HOOK_PYTHON_H
#define SBK_PYSIDE_HOOK_PYTHON_H

#include <sbkpython.h>
#include <conversions.h>
#include <sbkenum.h>
#include <basewrapper.h>
#include <bindingmanager.h>
#include <memory>

// Binded library includes
#include <PySideHook.h>
// Type indices
#define SBK_PYSIDEHOOK_IDX                                           0
#define SBK_pyside_hook_IDX_COUNT                                    1

// This variable stores all Python types exported by this module.
extern PyTypeObject** Sbkpyside_hookTypes;

// This variable stores all type converters exported by this module.
extern SbkConverter** Sbkpyside_hookTypeConverters;

// Converter indices
#define SBK_pyside_hook_CONVERTERS_IDX_COUNT                         1

// Macros for type check

namespace Shiboken
{

// PyType functions, to get the PyObjectType for a type T
template<> inline PyTypeObject* SbkType< ::PySideHook >() { return reinterpret_cast<PyTypeObject*>(Sbkpyside_hookTypes[SBK_PYSIDEHOOK_IDX]); }

} // namespace Shiboken

#endif // SBK_PYSIDE_HOOK_PYTHON_H

